import { h } from "@stencil/core";
export class TooltipComponent {
    constructor() {
        this.position = 'bottom';
    }
    showTooltip(event) {
        event.target.nextElementSibling.style.display = 'inline';
    }
    hideTooltip(event) {
        event.target.nextElementSibling.style.display = 'none';
    }
    render() {
        return (h("div", { key: '451f17c6e56b02685eddc6229cab017358a6734e', class: "tooltip-container", part: "tc__container" }, h("span", { key: 'c45c5e9eb460e3b99a9473a5c2cc03ed44b59d54', class: "info-icon", tabindex: "0", onFocus: this.showTooltip.bind(this), onBlur: this.hideTooltip.bind(this) }, h("slot", { key: '9b331edd4a47420e579198efa318a8f495715455', name: "tooltip-icon" }, "i")), h("span", { key: 'ebcc300e41299dc4d4f149168be1113dd84c1cc5', class: `tooltip-content ${this.position}`, part: "tc__content" }, h("slot", { key: 'cde8da69994197c92accbd30467359c1e035412b', name: "tooltip-content" }, "This is a help text."))));
    }
    static get is() { return "tooltip-component"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() {
        return {
            "$": ["tooltip-component.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["tooltip-component.css"]
        };
    }
    static get properties() {
        return {
            "position": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "'top' | 'bottom' | 'left' | 'right'",
                    "resolved": "\"bottom\" | \"left\" | \"right\" | \"top\"",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "The position of the tooltip."
                },
                "attribute": "position",
                "reflect": false,
                "defaultValue": "'bottom'"
            }
        };
    }
    static get elementRef() { return "el"; }
}
//# sourceMappingURL=toolitp-component.js.map
