var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
import { RegisterComponent } from "../../../common/register-component";
import { debug } from "../../../utils/utils";
import { Host, h } from "@stencil/core";
import i18next from "../../../utils/i18n";
export class NylasEventCapacity {
    constructor() {
        this.name = 'event-capacity';
        this.capacity = undefined;
        this.selectedLanguage = undefined;
        this.selectedEventCapacity = undefined;
        this.error = '';
    }
    connectedCallback() {
        debug('nylas-event-capacity', 'connectedCallback');
    }
    disconnectedCallback() {
        debug('nylas-event-capacity', 'disconnectedCallback');
    }
    componentWillLoad() {
        debug('nylas-event-capacity', 'componentWillLoad');
        this.host.setAttribute('name', this.name);
    }
    componentDidLoad() {
        debug('nylas-event-capacity', 'componentDidLoad');
        this.selectedEventCapacity = this.capacity || 10;
        console.log('selectedEventCapacity', this.selectedEventCapacity);
        this.internals.setFormValue(this.selectedEventCapacity.toString(), this.name);
    }
    componentWillUpdate() {
        debug('nylas-event-capacity', 'componentWillUpdate');
    }
    componentDidUpdate() {
        debug('nylas-event-capacity', 'componentDidUpdate');
    }
    componentWillRender() {
        debug('nylas-event-capacity', 'componentWillRender');
    }
    componentDidRender() {
        debug('nylas-event-capacity', 'componentDidRender');
    }
    elementNameChangedHandler(newValue) {
        debug('nylas-event-capacity', 'elementNameChangedHandler', newValue);
        this.host.setAttribute('name', newValue);
    }
    selectedLanguageChangedHandler(newVal, oldVal) {
        if (newVal === oldVal)
            return;
        i18next.changeLanguage(newVal);
    }
    async nylasFormInputChangeHandler(event) {
        const { name, value } = event.detail;
        if (name === 'event-capacity') {
            const parsedValue = parseInt(value);
            if (parsedValue < 1 || parsedValue > 500 || isNaN(parsedValue)) {
                this.error = i18next.t('fixFormErrors');
                this.internals.setValidity({ customError: true }, this.error);
                this.valueChanged.emit({ value: value.toString(), name: this.name });
                return;
            }
            this.error = '';
            this.internals.setValidity({ customError: false }, '');
            this.selectedEventCapacity = parseInt(value);
            this.internals.setFormValue(value.toString(), this.name);
            this.valueChanged.emit({ value: value.toString(), name: this.name });
        }
    }
    render() {
        const isComponentReady = typeof this.selectedEventCapacity !== 'undefined';
        return (h(Host, { key: '196c809c4eb92a68f27e3c57784c1de830216abc' }, h("div", { key: '503845c128cc0387e2b3830d05ee2f111c0136da', class: "nylas-event-capacity", part: "necapacity" }, h("label", { key: '83059d682337edaee48a0056172cf06abfc6c571', htmlFor: "event-capacity" }, h("span", { key: 'e38ab96339864cbf94d0b45a009d2c5e85f3d8cd' }, i18next.t('nylasEventCapacity.headerTitle'), h("span", { key: '325e2cdd6f545077c598e514334d65f2c187d133', class: "required" }, "*")), h("tooltip-component", { key: '2f845ee508a5d4d331c77d748070a85554251e29' }, h("info-icon", { key: 'f80932c1102ddd5e3e78804298a1e0ee7de4b4de', slot: "tooltip-icon" }), h("span", { key: 'c5bbb176f1b67ffd2639f1f95a2e5afec9319cd1', slot: "tooltip-content" }, i18next.t('nylasEventCapacity.tooltip.desc')))), isComponentReady && (h("div", { class: "nylas-event-capacity__wrapper" }, h("input-component", { name: "event-capacity", id: "event-capacity", type: "number", pattern: /^[0-9]*$/, patternError: i18next.t('invalidInputFormat', { field: 'Event capacity' }), minValue: 1, maxValue: 500, required: false, exportparts: "ic_input: necapacity__input-textfield", defaultValue: typeof this.selectedEventCapacity === 'number' ? this.selectedEventCapacity.toString() : '10' }), h("span", { class: this.error ? 'attendees error' : 'attendees' }, i18next.t('nylasEventCapacity.attendees')))))));
    }
    static get is() { return "nylas-event-capacity"; }
    static get encapsulation() { return "shadow"; }
    static get formAssociated() { return true; }
    static get originalStyleUrls() {
        return {
            "$": ["nylas-event-capacity.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["nylas-event-capacity.css"]
        };
    }
    static get properties() {
        return {
            "name": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [{
                            "name": "standalone",
                            "text": "The name of the component"
                        }],
                    "text": ""
                },
                "attribute": "name",
                "reflect": false,
                "defaultValue": "'event-capacity'"
            },
            "capacity": {
                "type": "number",
                "mutable": false,
                "complexType": {
                    "original": "number",
                    "resolved": "number | undefined",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [{
                            "name": "standalone",
                            "text": "The default event capacity"
                        }],
                    "text": ""
                },
                "attribute": "capacity",
                "reflect": false
            },
            "selectedLanguage": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "LANGUAGE_CODE",
                    "resolved": "LANGUAGE_CODE.de | LANGUAGE_CODE.en | LANGUAGE_CODE.es | LANGUAGE_CODE.fr | LANGUAGE_CODE.ja | LANGUAGE_CODE.ko | LANGUAGE_CODE.nl | LANGUAGE_CODE.sv | LANGUAGE_CODE.zh | undefined",
                    "references": {
                        "LANGUAGE_CODE": {
                            "location": "import",
                            "path": "@/common/constants",
                            "id": "src/common/constants.ts::LANGUAGE_CODE"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "The selected language."
                },
                "attribute": "selected-language",
                "reflect": false
            }
        };
    }
    static get states() {
        return {
            "selectedEventCapacity": {},
            "error": {}
        };
    }
    static get events() {
        return [{
                "method": "valueChanged",
                "name": "valueChanged",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": "This event is fired when the event capacity value changes"
                },
                "complexType": {
                    "original": "{\n    value: string;\n    name: string;\n    valueChanged?: (event: CustomEvent<{ value: string; name: string }>) => void;\n  }",
                    "resolved": "{ value: string; name: string; valueChanged?: ((event: CustomEvent<{ value: string; name: string; }>) => void) | undefined; }",
                    "references": {
                        "CustomEvent": {
                            "location": "global",
                            "id": "global::CustomEvent"
                        }
                    }
                }
            }];
    }
    static get elementRef() { return "host"; }
    static get watchers() {
        return [{
                "propName": "name",
                "methodName": "elementNameChangedHandler"
            }, {
                "propName": "selectedLanguage",
                "methodName": "selectedLanguageChangedHandler"
            }];
    }
    static get listeners() {
        return [{
                "name": "nylasFormInputChanged",
                "method": "nylasFormInputChangeHandler",
                "target": undefined,
                "capture": false,
                "passive": false
            }];
    }
    static get attachInternalsMemberName() { return "internals"; }
}
__decorate([
    RegisterComponent({
        name: 'nylas-event-capacity',
        stateToProps: new Map([['schedulerConfig.selectedLanguage', 'selectedLanguage']]),
        eventToProps: {
            valueChanged: async (event, _nylasSchedulerConfigConnector) => {
                const { valueChanged } = event.detail;
                if (valueChanged) {
                    valueChanged(event);
                }
            },
        },
        fireRegisterEvent: true,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NylasEventCapacity.prototype, "render", null);
//# sourceMappingURL=nylas-event-capacity.js.map
