import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const loadingCss = ".wave{display:flex;align-items:center;justify-content:center}.dot{width:4px;height:4px;background-color:var(--dot-color, white);border-radius:50%;margin:0 2px;animation:wave 1.5s infinite ease-in-out}.dot:nth-child(2){animation-delay:0.2s}.dot:nth-child(3){animation-delay:0.4s}@keyframes wave{0%,60%,100%{transform:translateY(0)}30%{transform:translateY(-4px)}}";
const LoadingIconStyle0 = loadingCss;

const LoadingIcon = proxyCustomElement(class LoadingIcon extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.width = '15';
        this.height = '15';
    }
    render() {
        return (h("div", { key: 'f57596041d2b245a61e68b619e1611b562ac0ea9', class: "wave" }, h("div", { key: 'ee8a655c6584adfa4f0f89c50d4b60959067573c', class: "dot" }), h("div", { key: 'f619f493ca925ed91134aba6feadaba916517739', class: "dot" }), h("div", { key: 'a8fd3592f3452bd5b4f5f0e64c55e56075a78a61', class: "dot" })));
    }
    static get style() { return LoadingIconStyle0; }
}, [1, "loading-icon", {
        "width": [1],
        "height": [1]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["loading-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "loading-icon":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, LoadingIcon);
            }
            break;
    } });
}

export { LoadingIcon as L, defineCustomElement as d };

//# sourceMappingURL=loading.js.map